{{File: ServosObjectExample.spin
This example top file controls two servos with the Serovs object and relies
on the Integer Ramping object to incrementally adjust the servo control signal
when it requests large changes.  This helps improve continuous rotation servo
life expectancies and traction in some cases.

NOTE: This object is a work in progress and is not ready to be posted to the
Parallax Object Library.
}}
      
CON

  L = 0
  R = 1

VAR

  ' Declare 2 servo array variables.
  byte cog
  long servo[2], pinL, pinR, stack[50]
  long pl, pr, maneuver, duration, mode
  long pcnt  

OBJ

  ' Declare servo object and name it (s in this case).
  s       : "Servos"
  ramp[2] : "Integer Ramping"

PUB start(ServoPinLeft, ServoPinRight, StartManeuver, StartDuration, DriveMode) : okay

  longmove(@pl, @ServoPinLeft, 5)
  init(pl, pr)
  okay := cog := cognew(main, @stack) + 1

PUB stop

  if cog
    cogstop(cog~ - 1)

PUB init(ServoPinLeft, ServoPinRight)

  pinL := ServoPinLeft
  pinR := ServoPinRight

  servo[0] := 0                              
  servo[1] := 0

  pcnt := s.start(pinL, pinR, @servo)                

  ramp[L].init(0, 2000, -2000,  1000, -1000)
  ramp[R].init(0, 2000, -2000,  1000, -1000)


CON

  FORWARD        =  0
  BACKWARD       =  1
  ROTATE_LEFT    =  2
  ROTATE_RIGHT   =  3
  SIT_STILL      =  4
  SERVOS_OFF     =  5
  SERVOS_RESTART =  6
        
PUB go(_maneuver)

  maneuver := _maneuver

PRI main | pcntOLd

  repeat
  
    repeat until long[pcnt][0] <> pcntOld
    pcntOld := long[pcnt][0]
    
    case maneuver
      FORWARD:
        servo[L] := ramp[L].calculate(1000)
        servo[R] := ramp[R].calculate(-1000)
      BACKWARD:
        servo[L] := ramp[L].calculate(-1000)
        servo[R] := ramp[R].calculate(1000)
      ROTATE_LEFT:
        servo[L] := ramp[L].calculate(-1000)
        servo[R] := ramp[R].calculate(-1000)
      ROTATE_RIGHT:
        servo[L] := ramp[L].calculate(1000)
        servo[R] := ramp[R].calculate(1000)
      SIT_STILL:
        servo[L] := servo[R] := 0  
      SERVOS_OFF:
        s.stop
      SERVOS_RESTART:
        pcnt := s.start(pinL, pinR, @servo)
    

  